﻿using System;
using System.Collections.Generic;
using UnityEngine;
using System.IO;

public class MeshImporter
{
    static Moonfish.Core.Model.Mesh Input;
    static UnityEngine.Mesh Output;

    public static UnityEngine.Mesh Import(Moonfish.Core.Model.Mesh mesh)
    {
        Input = mesh;

        Output = new UnityEngine.Mesh();
        Output.Clear();

        AddVertices();
        AddTriangles();
        AddUVs();
        AddNormals();
        //AddMaterials();

        Output.RecalculateBounds();
        return Output;
    }

    static void AddVertices()
    {
        Vector3[] vertices = new Vector3[Input.Vertices.Length];
        for (int i = 0; i < Input.Vertices.Length; i++)
            vertices[i] = Input.Vertices[i].Position;
        Output.vertices = vertices;
    }

    static void AddTriangles()
    {
        int[] triangles = new int[Input.Indices.Length];
        for (int i = 0; i < Input.Vertices.Length; i++)
            triangles[i] = Input.Indices[i];
        Output.SetTriangleStrip(triangles, 0);
    }

    static void AddUVs()
    {
        Vector2[] uv = new Vector2[Input.Vertices.Length];
        for (int i = 0; i < Input.Vertices.Length; i++)
            uv[i] = Input.Vertices[i].TextureCoordinates;
        Output.uv = uv;
    }

    static void AddNormals()
    {
        Vector3[] normals = new Vector3[Input.Vertices.Length];
        for (int i = 0; i < Input.Vertices.Length; i++)
            normals[i] = Input.Vertices[i].Normal;
        Output.normals = normals;
    }

    //static void AddMaterials()
    //{
    //    renderer.material = new Material(Shader.Find("Diffuse"));
    //}
}
