﻿using Moonfish.Core;
using System.Collections.Generic;
using System.Text;
using System;

public class GlobalStrings : IEnumerable<string>, IEnumerable<StringID>
{
    static readonly string[] Strings;
    static readonly StringID[] String_IDs;

    static GlobalStrings()
    {
        #region Strings
        Strings = new string[]{
                "",
                "default",
                "reload_1",
                "reload_2",
                "chamber_1",
                "chamber_2",
                "fire_1",
                "fire_2",
                "charged_1",
                "charged_2",
                "melee",
                "overheat",
                "idle",
                "gesture",
                "turn_left",
                "turn_right",
                "dive_front",
                "dive_back",
                "dive_left",
                "dive_right",
                "move_front",
                "move_back",
                "move_left",
                "move_right",
                "slide_front",
                "slide_back",
                "slide_left",
                "slide_right",
                "climb_up",
                "climb_down",
                "airborne",
                "land_soft",
                "land_hard",
                "throw_grenade",
                "disarm",
                "drop",
                "ready",
                "put_away",
                "aim_still_up",
                "aim_move_up",
                "aim_still_down",
                "aim_move_down",
                "surprise_front",
                "surprise_back",
                "berserk",
                "evade_left",
                "evade_right",
                "signal_move",
                "signal_attack",
                "warn",
                "stunned_front",
                "stunned_back",
                "stunned_left",
                "stunned_right",
                "celebrate",
                "panic",
                "melee_airborne",
                "flaming",
                "resurrect_front",
                "resurrect_back",
                "melee_continuous",
                "feeding",
                "leap_start",
                "leap_airborne",
                "leap_melee",
                "zapping",
                "airborne_dead",
                "landing_dead",
                "acc_front_back",
                "acc_left_right",
                "acc_up_down",
                "push",
                "twist",
                "enter",
                "exit",
                "look",
                "talk",
                "emotions",
                "user0",
                "user1",
                "user2",
                "user3",
                "user4",
                "user5",
                "user6",
                "user7",
                "user8",
                "user9",
                "flying_front",
                "flying_back",
                "flying_left",
                "flying_right",
                "opening",
                "closing",
                "hovering",
                "posing",
                "moving",
                "overlays",
                "light_off",
                "light_on",
                "reload_empty",
                "reload_full",
                "overheated",
                "overcharged",
                "overcharged_jitter",
                "ammunition",
                "misfire_1",
                "misfire_2",
                "throw_overheated",
                "overheating",
                "ready_overheated",
                "exit_empty",
                "exit_full",
                "o_h_exit",
                "o_h_s_enter",
                "melee_1sthit",
                "melee_1sthit2idle",
                "melee_2ndhit",
                "melee_2ndhit2idle",
                "melee_3rdhit",
                "steering",
                "roll",
                "throttle",
                "velocity",
                "braking",
                "ground_speed",
                "occupied",
                "unoccupied",
                "position",
                "power",
                "c_dropship",
                "unarmed",
                "asleep",
                "patrol",
                "combat",
                "crouch",
                "active_camouflage",
                "flee",
                "unused",
                "s_ping",
                "h_ping",
                "s_kill",
                "h_kill",
                "front",
                "left",
                "right",
                "back",
                "gut",
                "chest",
                "head",
                "l_arm",
                "l_hand",
                "l_leg",
                "l_foot",
                "r_arm",
                "r_hand",
                "r_leg",
                "r_foot",
                "liquid",
                "soft",
                "energy",
                "hard",
                "brittle",
                "liquid_thin_water",
                "hard_metal_thin",
                "hard_floodflesh",
                "hard_metal_thick",
                "hard_metal_solid",
                "hard_terrain",
                "soft_flesh",
                "soft_floodflesh",
                "soft_cloth",
                "soft_armor",
                "soft_plant",
                "soft_rubber",
                "soft_terrain",
                "energy_shield_heavy",
                "energy_shield",
                "brittle_electronic",
                "brittle_glass",
                "brittle_mechanical",
                "soft_terrain_dirt",
                "flashlight",
                "incident",
                "normal",
                "reflected",
                "midpoint",
                "hover_thrusters",
                "jet_thrusters",
                "body",
                "negative_incident",
                "reflection",
                "gravity",
                "ground_point",
                "user_animation",
                "board",
                "ejection",
                "suspension_left_front",
                "suspension_right_front",
                "suspension_left_back",
                "suspension_right_back",
                "stunned",
                "up",
                "climb",
                "attach",
                "detach",
                "weapon",
                "vehicle",
                "suspension",
                "device",
                "object",
                "small",
                "medium",
                "large",
                "walk",
                "run",
                "sprint",
                "any",
                "first_person",
                "primary_trigger",
                "secondary_trigger",
                "fp_body_cam",
                "pitch_and_turn",
                "tread",
                "camera_control",
                "death_falling",
                "death_agonizing",
                "death_flying",
                "death_quiet",
                "death_instant",
                "death_violent",
                "pain_falling",
                "pain_shield_minor",
                "pain_shield_major",
                "pain_body_minor",
                "pain_body_major",
                "mp_1st_place",
                "mp_2nd_place",
                "mp_3rd_place",
                "mp_4th_place",
                "mp_5th_place",
                "mp_6th_place",
                "mp_7th_place",
                "mp_8th_place",
                "mp_9th_place",
                "mp_10th_place",
                "mp_11th_place",
                "mp_12th_place",
                "mp_13th_place",
                "mp_14th_place",
                "mp_15th_place",
                "mp_16th_place",
                "mp_kills",
                "mp_wins",
                "mp_assists",
                "mp_deaths",
                "left_hand",
                "current",
                "mp_score",
                "mp_place",
                "mp_laps",
                "mp_name",
                "mp_quit",
                "mp_dead",
                "mp_game_over",
                "mp_round_over",
                "mp_waiting_for_next_round",
                "campaign",
                "warfare",
                "capture_the_flag",
                "assault",
                "slayer",
                "oddball",
                "king_of_the_hill",
                "race",
                "juggernaut",
                "headhunter",
                "territories",
                "mp_score_display_winning",
                "mp_score_display_tied",
                "mp_score_display_losing",
                "mp_odd_man_out",
                "mp_out_of_lives",
                "mp_respawn_timer",
                "mp_waiting_for_space",
                "mp_press_back_for_score",
                "death_default",
                "death_impact",
                "death_massive",
                "death_tormented",
                "death_headshot",
                "death_silent",
                "death_dramatic",
                "pain_default",
                "pain_medium",
                "pain_major",
                "pain_shield",
                "pain_impact",
                "dry",
                "sfx_extra_sound_inputs",
                "sfx_oscillator",
                "sfx_mono_distortion",
                "sfx_mono_iir2",
                "sfx_mono_amp_mod",
                "sfx_mono_chorus",
                "sfx_mono_echo",
                "sfx_mono_flange",
                "sfx_stereo_amp_mod",
                "sfx_stereo_chorus",
                "sfx_oscillator_input",
                "sfx_front_speaker_chorus",
                "sfx_back_speaker_chorus",
                "sfx_global_chorus",
                "sfx_stereo_echo",
                "sfx_stereo_flange",
                "sfx_mono_iir2_chain",
                "sfx_controller_voice_0",
                "sfx_controller_voice_1",
                "sfx_controller_voice_2",
                "sfx_controller_voice_3",
                "controller_0_headset",
                "controller_1_headset",
                "controller_2_headset",
                "controller_3_headset",
                "continue",
                "phonemes",
                "ok_button_label",
                "cancel_button_label",
                "generic_error",
                "generic_networking_error",
                "system_link_generic_join_failure",
                "system_link_no_network_connection",
                "system_link_connection_lost",
                "system_link_join_failed",
                "network_game_oos",
                "xbox_live_sign_out_confirmation",
                "confirm_revert_to_last_save",
                "confirm_quit_without_save",
                "confirm_delete_player_profile",
                "confirm_delete_variant_file",
                "core_file_load_failed",
                "mu_removed_during_player_profile_save",
                "mu_removed_during_variant_save",
                "mu_removed_during_playlist_save",
                "message_saving_to_mu",
                "message_saving_file",
                "message_creating_player_profile",
                "message_creating_variant_profile",
                "message_saving_checkpoint",
                "loading_large_content",
                "failed_to_load_player_profile",
                "failed_to_load_variant",
                "failed_to_load_playlist",
                "failed_to_load_save_game",
                "error_controller1_removed_text",
                "error_controller2_removed_text",
                "error_controller3_removed_text",
                "error_controller4_removed_text",
                "need_more_free_blocks_to_save",
                "maximum_saved_game_files_already_exist",
                "error_cannot_access_service",
                "error_account_management_required",
                "warning_recommended_messages_available",
                "error_invalid_match_session",
                "warning_poor_network_performance",
                "error_not_enough_open_slots_to_join_match_session",
                "error_corrupt_download_content",
                "confirm_corrupt_saved_game_file_removal",
                "confirm_boot_player_from_squad",
                "confirm_controller_sign_out",
                "confirm_friend_removal",
                "confirm_launch_xdemos",
                "confirm_exit_game_session",
                "gametype_campaign",
                "gametype_warfare",
                "gametype_ctf",
                "gametype_assault",
                "gametype_slayer",
                "gametype_oddball",
                "gametype_koth",
                "gametype_race",
                "gametype_juggernaut",
                "gametype_headhunter",
                "gametype_territories",
                "unknown",
                "on",
                "off",
                "enabled",
                "disabled",
                "vehicle_set_all",
                "vehicle_set_none",
                "vehicle_set_warthog",
                "vehicle_set_ghost",
                "vehicle_set_tank",
                "vehicle_set_banshee",
                "mp_score_place_header",
                "mp_score_name_header",
                "mp_score_kills_header",
                "mp_score_assists_header",
                "mp_score_deaths_header",
                "mp_telefragged_message",
                "mp_teleporter_blocked_message",
                "mp_score_flags_header",
                "mp_score_laps_header",
                "mp_time_header",
                "create_new_profile",
                "settings_player_profile",
                "settings_variant",
                "settings_playlist",
                "player_profile_chosen_for_edit",
                "multiplayer_variant_chosen_for_edit",
                "multiplayer_playlist_chosen_for_edit",
                "variant_header",
                "profile_header",
                "edit",
                "rename",
                "delete",
                "create_new_playlist",
                "eye_left",
                "eye_right",
                "amorous",
                "happy",
                "inquisitive",
                "repulsed",
                "disappointed",
                "shocked",
                "scared",
                "arrogant",
                "annoyed",
                "angry",
                "pensive",
                "pain",
                "mp_connecting",
                "mp_observer",
                "mp_observer_team",
                "ui",
                "corner_cover_left",
                "corner_cover_right",
                "corner_cover_center",
                "leave_game",
                "player_settings",
                "set_handicap",
                "change_teams",
                "squad_leader_admininstration",
                "player_status",
                "end_game",
                "red",
                "blue",
                "green",
                "yellow",
                "purple",
                "orange",
                "brown",
                "grey",
                "observers",
                "slayer_description_text",
                "king_of_the_hill_description_text",
                "race_description_text",
                "oddball_description_text",
                "juggernaut_description_text",
                "headhunter_description_text",
                "capture_the_flag_description_text",
                "assault_description_text",
                "territories_description_text",
                "warfare_description_text",
                "slayer_uppercase",
                "king_of_the_hill_uppercase",
                "race_uppercase",
                "oddball_uppercase",
                "juggernaut_uppercase",
                "headhunter_uppercase",
                "capture_the_flag_uppercase",
                "assault_uppercase",
                "territories_uppercase",
                "warfare_uppercase",
                "create_new_variant",
                "built_in_variant",
                "header_text",
                "status_label",
                "gametype_format",
                "coop_campaign",
                "mapname_format",
                "gametype_options_format",
                "no_session",
                "not_pregame",
                "need_2_teams",
                "need_3_teams",
                "need_4_teams",
                "need_5_teams",
                "need_6_teams",
                "need_7_teams",
                "need_8_teams",
                "coop_takes_two",
                "not_squad_leader",
                "waiting_on_squad_leader",
                "game_start_when_you_get_off_your_ass",
                "game_start_countdown_in_progress",
                "value",
                "not_in_squad",
                "invalid_hopper",
                "player_skill_levels_not_available",
                "skill_maximum_level_spread_exceeded",
                "squad_can_not_contain_guests",
                "squad_too_small",
                "squad_too_large",
                "squad_not_clan_based",
                "squad_with_multiple_clans",
                "host_bandwidth_too_low",
                "missing_content",
                "vehicle_set_value",
                "weapon_set_value",
                "game_options_value",
                "win_condition_value",
                "open",
                "invitation_only",
                "closed",
                "variant_name",
                "no_map_selected",
                "machine_joining",
                "bungienet_user_restriction",
                "precaching",
                "precaching_failed",
                "no_map_selected_leader",
                "game_start_countdown_in_progress_not_leader",
                "countdown_delayed_by_player",
                "countdown_canceled",
                "team0",
                "team1",
                "team2",
                "team3",
                "team4",
                "team5",
                "team6",
                "team7",
                "button_key_squad_leader_teams_disabled",
                "button_key_squad_leader_teams_enabled",
                "button_key_peon_teams_disabled",
                "button_key_peon_teams_enabled",
                "button_key_countdown_in_progress",
                "button_key_countdown_in_progress_cancel",
                "none",
                "5_minutes",
                "10_minutes",
                "15_minutes",
                "30_minutes",
                "60_minutes",
                "120_minutes",
                "i_do_not_agree",
                "i_agree",
                "wall_leaning_left",
                "wall_leaning_right",
                "wall_leaning_open_left",
                "wall_leaning_open_right",
                "corner_open_left",
                "corner_open_right",
                "impact",
                "smash_forward",
                "smash_left",
                "smash_right",
                "create_new_account",
                "donot_sign_in",
                "guest_of_ascii_gamertag_unicode_format_string",
                "mp_time",
                "header",
                "no_games",
                "joining",
                "create_new_game",
                "koth",
                "none_open",
                "idle_open",
                "matchmaking_open",
                "pregame_open",
                "pregame_ready_open",
                "ingame_open",
                "postgame_open",
                "none_invite",
                "idle_invite",
                "matchmaking_invite",
                "pregame_invite",
                "pregame_ready_invite",
                "ingame_invite",
                "postgame_invite",
                "none_closed",
                "idle_closed",
                "matchmaking_closed",
                "pregame_closed",
                "pregame_ready_closed",
                "ingame_closed",
                "postgame_closed",
                "mouth_closed",
                "offline",
                "online_generic",
                "online_your_party_leader",
                "online_in_your_party",
                "online_in_your_game",
                "online_in_a_party",
                "online_closed",
                "online_invite_only",
                "online_joinable",
                "online_not_joinable",
                "online_in_menu",
                "online_playing_campaign",
                "online_playing_party_game",
                "online_in_matchmaking",
                "online_in_other_game",
                "playing_in_other_game",
                "online_mgs_in_menu",
                "online_mgs_downloading",
                "online_mgs_replay",
                "online_mgs_searching_for_games",
                "online_mgs_solo_game",
                "online_mgs_multiplayer_game",
                "online_time_elapsed",
                "online_time_remaining",
                "friend_invite_received",
                "friend_invite_sent",
                "cross_game_invite_received",
                "party_invite_received",
                "game_invite_sent",
                "in_open_pregame_lobby",
                "in_closed_pregame_lobby",
                "in_open_postgame_lobby",
                "in_closed_postgame_lobby",
                "in_open_arranged_game",
                "in_closed_arranged_game",
                "joining_a_game",
                "playing_matchmade_game",
                "game_type_arranged",
                "game_type_clan",
                "game_type_match",
                "game_type_coop",
                "rule_type",
                "team",
                "ffa",
                "player_score",
                "team_score",
                "round_time_remaining",
                "round_time_elapsed",
                "player_number_name",
                "recent_player",
                "status_unavailable",
                "vault",
                "hint_vault",
                "xbox_live",
                "splitscreen",
                "systemlink",
                "settings",
                "saved_films",
                "game_demos",
                "create_new_description_text",
                "press_a_to_join",
                "insert_controller",
                "press_a_to_continue",
                "mp_map_select_no_maps_found",
                "easy",
                "heroic",
                "legendary",
                "good_attitude",
                "fun_session",
                "bad_nickname",
                "cheating",
                "verbally_abusive",
                "harassment",
                "lewdness",
                "bad_clan_name",
                "message_spam",
                "message_inappropriate",
                "message_type_text",
                "message_type_voice",
                "friend_list_options",
                "add_friend_by_gamertag",
                "view_personal_stats",
                "message_spam_all_friends",
                "invite_spam_all_friends",
                "add_clanmate_by_gamertag",
                "message_spam_all_clanmates",
                "invite_spam_all_clanmates",
                "leave_clan",
                "send_message",
                "view_message",
                "join_squad",
                "join_game",
                "view_player_profile",
                "view_clan_profile",
                "send_feedback",
                "reply_to_message",
                "send_game_invite",
                "cancel_game_invite",
                "accept_game_invite",
                "decline_game_invite",
                "accept_party_invite",
                "decline_party_invite",
                "send_friend_request",
                "accept_friend_request",
                "decline_friend_request",
                "decline_and_block_friend_request",
                "cancel_friend_request",
                "remove_from_friends_list",
                "send_clan_request",
                "accept_clan_request",
                "decline_clan_request",
                "decline_and_block_clan_request",
                "cancel_clan_request",
                "remove_from_clan",
                "change_clan_privileges",
                "mute",
                "unmute",
                "boot_from_squad",
                "confirm_leave_current_clan",
                "warn_no_more_clan_superusers",
                "peon",
                "member",
                "administrator",
                "superuser",
                "confirm_leave_clan",
                "confirm_promotion_to_superuser",
                "friend_request_message_header",
                "game_invite_message_header",
                "party_invite_message_header",
                "party_invite_message_to_friends_header",
                "party_invite_message_to_clanmates_header",
                "clan_request_message_header",
                "tournament_reminder_message_header",
                "tournament_invite_header",
                "system_message_header",
                "title_message_header",
                "title_message_to_friends_header",
                "title_message_to_clanmates_header",
                "generic_message_header",
                "play_voice_attachment",
                "default_party_text",
                "default_game_text",
                "default_friend_text",
                "default_clan_text",
                "default_message_text",
                "sent_am",
                "sent_pm",
                "voice_mail_present",
                "voice_mail_absent",
                "key_default",
                "skip_message",
                "delete_message",
                "clan_list_options",
                "clan_create",
                "clan_invite_received",
                "clan_invite_sent",
                "revert_to_last_save",
                "restart_level",
                "save_and_quit",
                "quit",
                "rename_profile",
                "controller_settings",
                "appearance_settings",
                "subtitles_settings",
                "xbox_live_settings",
                "voice_settings",
                "delete_profile",
                "southpaw",
                "legacy",
                "legacy_southpaw",
                "player_model",
                "change_color0_name",
                "change_color1_name",
                "change_color2_name",
                "change_color3_name",
                "emblem_foreground",
                "emblem_background",
                "spartan",
                "covenant",
                "voice_masking",
                "voice_output",
                "anonymous",
                "voice_default",
                "voice_output_only_through_tv_speakers",
                "voice_output_only_through_headset",
                "voice_disabled",
                "enable",
                "disable",
                "0",
                "1",
                "2",
                "3",
                "4",
                "5",
                "6",
                "7",
                "8",
                "9",
                "10",
                "11",
                "12",
                "13",
                "14",
                "15",
                "16",
                "17",
                "18",
                "19",
                "20",
                "21",
                "22",
                "23",
                "24",
                "25",
                "26",
                "27",
                "28",
                "29",
                "30",
                "31",
                "32",
                "33",
                "34",
                "35",
                "36",
                "37",
                "38",
                "39",
                "40",
                "41",
                "42",
                "43",
                "44",
                "45",
                "46",
                "47",
                "48",
                "49",
                "50",
                "51",
                "52",
                "53",
                "54",
                "55",
                "56",
                "57",
                "58",
                "59",
                "60",
                "61",
                "62",
                "63",
                "64",
                "65",
                "66",
                "67",
                "68",
                "69",
                "70",
                "71",
                "72",
                "73",
                "74",
                "75",
                "76",
                "77",
                "78",
                "79",
                "80",
                "81",
                "82",
                "83",
                "84",
                "85",
                "86",
                "87",
                "88",
                "89",
                "90",
                "91",
                "92",
                "93",
                "94",
                "95",
                "96",
                "97",
                "98",
                "99",
                "100",
                "foreground0",
                "foreground1",
                "foreground2",
                "foreground3",
                "foreground4",
                "foreground5",
                "foreground6",
                "foreground7",
                "foreground8",
                "foreground9",
                "foreground10",
                "foreground11",
                "foreground12",
                "foreground13",
                "foreground14",
                "foreground15",
                "foreground16",
                "foreground17",
                "foreground18",
                "foreground19",
                "foreground20",
                "foreground21",
                "foreground22",
                "foreground23",
                "foreground24",
                "foreground25",
                "foreground26",
                "foreground27",
                "foreground28",
                "foreground29",
                "foreground30",
                "foreground31",
                "foreground32",
                "foreground33",
                "foreground34",
                "foreground35",
                "foreground36",
                "foreground37",
                "foreground38",
                "foreground39",
                "foreground40",
                "foreground41",
                "foreground42",
                "foreground43",
                "foreground44",
                "foreground45",
                "foreground46",
                "foreground47",
                "foreground48",
                "foreground49",
                "foreground50",
                "foreground51",
                "foreground52",
                "foreground53",
                "foreground54",
                "foreground55",
                "foreground56",
                "foreground57",
                "foreground58",
                "foreground59",
                "foreground60",
                "foreground61",
                "foreground62",
                "foreground63",
                "background0",
                "background1",
                "background2",
                "background3",
                "background4",
                "background5",
                "background6",
                "background7",
                "background8",
                "background9",
                "background10",
                "background11",
                "background12",
                "background13",
                "background14",
                "background15",
                "background16",
                "background17",
                "background18",
                "background19",
                "background20",
                "background21",
                "background22",
                "background23",
                "background24",
                "background25",
                "background26",
                "background27",
                "background28",
                "background29",
                "background30",
                "background31",
                "look_sensitivity_1",
                "look_sensitivity_2",
                "look_sensitivity_3",
                "look_sensitivity_4",
                "look_sensitivity_5",
                "look_sensitivity_6",
                "look_sensitivity_7",
                "look_sensitivity_8",
                "look_sensitivity_9",
                "look_sensitivity_10",
                "handicap_1",
                "handicap_2",
                "handicap_3",
                "handicap_4",
                "thumbstick_settings",
                "button_settings",
                "look_sensitivity",
                "invert_look",
                "auto_center",
                "vibration",
                "standard",
                "south_paw",
                "boxer",
                "green_thumb",
                "appear_offline",
                "inactive_status",
                "voice_through_tv",
                "never",
                "number_of_lives",
                "infinite",
                "maximum_health",
                "50_percent",
                "100_percent",
                "150_percent",
                "200_percent",
                "300_percent",
                "400_percent",
                "shields",
                "respawn_time",
                "instant",
                "5_seconds",
                "10_seconds",
                "15_seconds",
                "maximum_simultaneous_players",
                "all",
                "invisible_players",
                "suicide_penalty",
                "friendly_fire",
                "respawn_grenades",
                "power_ups",
                "pistols",
                "rifles",
                "plasma",
                "sniper",
                "no_sniper",
                "rockets",
                "shotguns",
                "short_range",
                "human",
                "no_grenades",
                "custom",
                "generic",
                "warthogs",
                "ghosts",
                "scorpion_tanks",
                "banshees",
                "mongoose_atvs",
                "shadows",
                "wraiths",
                "objective_indicators",
                "motion_tracker",
                "nav_points",
                "players_in_motion_sensor",
                "invisible_players_on_motion_sensor",
                "friend_indicators_on_screen",
                "enemy_indicators",
                "contents_add_new_entry",
                "more_variants",
                "select_for_play",
                "solo_level_select_unavailable",
                "quickmatch",
                "optimatch",
                "custom_game",
                "playlist",
                "coop",
                "solo",
                "resume_solo_campaign",
                "restart_solo_campaign",
                "restart_coop_campaign",
                "start_game",
                "choose_game",
                "quick_options",
                "boot_player",
                "rename_lobby",
                "abdicate_leadership",
                "gametype_settings",
                "item_options",
                "player_options",
                "indicator_options",
                "description_text",
                "vehicle_options",
                "match_options",
                "team_options",
                "equipment_options",
                "split_screen",
                "system_link",
                "ctf",
                "matchmaking_inactive",
                "matchmaking_failed",
                "matchmaking_aborted",
                "searching_for_games",
                "gathering_game",
                "joining_game",
                "starting_game",
                "matchmaking_successful",
                "versus",
                "leaving_squad",
                "view_live_profile",
                "content_download",
                "clan",
                "motd",
                "squads",
                "header_player_profile_name_entry",
                "player_profile_name_help_text",
                "player_profile_for_solo_campaign_help",
                "variant_name_entry",
                "variant_name_help_text",
                "variant_name_rename_default_help_text",
                "playlist_name",
                "playlist_help_text",
                "saved_film_name",
                "saved_film_help_text",
                "gamertag_entry",
                "gamertag_help_text",
                "clanmate_gamertag_entry",
                "clanmate_gamertag_help_text",
                "message_entry",
                "message_help_text",
                "squad_name_entry",
                "squad_name_help_text",
                "clan_create_entry",
                "clan_create_help_text",
                "clan_description_entry",
                "clan_description_help_text",
                "clan_motto_entry",
                "clan_motto_help_text",
                "clan_url_entry",
                "clan_url_help_text",
                "numeral_one",
                "numeral_two",
                "numeral_three",
                "numeral_four",
                "numeral_five",
                "numeral_six",
                "numeral_seven",
                "numeral_eight",
                "numeral_nine",
                "numeral_zero",
                "lowercase_a",
                "lowercase_b",
                "lowercase_c",
                "lowercase_d",
                "lowercase_e",
                "lowercase_f",
                "lowercase_g",
                "lowercase_h",
                "lowercase_i",
                "lowercase_j",
                "lowercase_k",
                "lowercase_l",
                "lowercase_m",
                "lowercase_n",
                "lowercase_o",
                "lowercase_p",
                "lowercase_q",
                "lowercase_r",
                "lowercase_s",
                "lowercase_t",
                "lowercase_u",
                "lowercase_v",
                "lowercase_w",
                "lowercase_x",
                "lowercase_y",
                "lowercase_z",
                "shift_one",
                "shift_two",
                "shift_three",
                "shift_four",
                "shift_five",
                "shift_six",
                "shift_seven",
                "shift_eight",
                "shift_nine",
                "shift_zero",
                "uppercase_a",
                "uppercase_b",
                "uppercase_c",
                "uppercase_d",
                "uppercase_e",
                "uppercase_f",
                "uppercase_g",
                "uppercase_h",
                "uppercase_i",
                "uppercase_j",
                "uppercase_k",
                "uppercase_l",
                "uppercase_m",
                "uppercase_n",
                "uppercase_o",
                "uppercase_p",
                "uppercase_q",
                "uppercase_r",
                "uppercase_s",
                "uppercase_t",
                "uppercase_u",
                "uppercase_v",
                "uppercase_w",
                "uppercase_x",
                "uppercase_y",
                "uppercase_z",
                "accent_one",
                "accent_two",
                "accent_three",
                "accent_four",
                "accent_five",
                "accent_six",
                "accent_seven",
                "accent_eight",
                "accent_nine",
                "accent_zero",
                "accent_a",
                "accent_b",
                "accent_c",
                "accent_d",
                "accent_e",
                "accent_f",
                "accent_g",
                "accent_h",
                "accent_i",
                "accent_j",
                "accent_k",
                "accent_l",
                "accent_m",
                "accent_n",
                "accent_o",
                "accent_p",
                "accent_q",
                "accent_r",
                "accent_s",
                "accent_t",
                "accent_u",
                "accent_v",
                "accent_w",
                "accent_x",
                "accent_y",
                "accent_z",
                "shift_accent_one",
                "shift_accent_two",
                "shift_accent_three",
                "shift_accent_four",
                "shift_accent_five",
                "shift_accent_six",
                "shift_accent_seven",
                "shift_accent_eight",
                "shift_accent_nine",
                "shift_accent_zero",
                "shift_accent_a",
                "shift_accent_b",
                "shift_accent_c",
                "shift_accent_d",
                "shift_accent_e",
                "shift_accent_f",
                "shift_accent_g",
                "shift_accent_h",
                "shift_accent_i",
                "shift_accent_j",
                "shift_accent_k",
                "shift_accent_l",
                "shift_accent_m",
                "shift_accent_n",
                "shift_accent_o",
                "shift_accent_p",
                "shift_accent_q",
                "shift_accent_r",
                "shift_accent_s",
                "shift_accent_t",
                "shift_accent_u",
                "shift_accent_v",
                "shift_accent_w",
                "shift_accent_x",
                "shift_accent_y",
                "shift_accent_z",
                "symbol_numeral_one",
                "symbol_numeral_two",
                "symbol_numeral_three",
                "symbol_numeral_four",
                "symbol_numeral_five",
                "symbol_numeral_six",
                "symbol_numeral_seven",
                "symbol_numeral_eight",
                "symbol_numeral_nine",
                "symbol_numeral_zero",
                "symbol_a",
                "symbol_b",
                "symbol_c",
                "symbol_d",
                "symbol_e",
                "symbol_f",
                "symbol_g",
                "symbol_h",
                "symbol_i",
                "symbol_j",
                "symbol_k",
                "symbol_l",
                "symbol_m",
                "symbol_n",
                "symbol_o",
                "symbol_p",
                "symbol_q",
                "symbol_r",
                "symbol_s",
                "symbol_t",
                "symbol_u",
                "symbol_v",
                "symbol_w",
                "symbol_x",
                "symbol_y",
                "symbol_z",
                "done",
                "shift",
                "caps_lock",
                "accents",
                "symbols",
                "space",
                "backspace",
                "left_arrow",
                "right_arrow",
                "objectives_header",
                "walk_front",
                "walk_back",
                "walk_left",
                "walk_right",
                "default_material",
                "hint_vault_step",
                "hint_vault_crouch",
                "hint_vault_stand",
                "hint_vault_tall",
                "hint_mount_step",
                "hint_mount_crouch",
                "hint_mount_stand",
                "hint_mount_tall",
                "hint_hoist_step",
                "hint_hoist_crouch",
                "hint_hoist_stand",
                "hint_hoist_tall",
                "physics_control",
                "origin_marker",
                "hoist",
                "disarm_left",
                "drop_left",
                "ready_left",
                "ready_left_overheated",
                "put_away_left",
                "reload_1_left",
                "reload_2_left",
                "chamber_1_left",
                "chamber_2_left",
                "fire_1_left",
                "fire_2_left",
                "charged_1_left",
                "charged_2_left",
                "flight",
                "takeoff",
                "perch",
                "perch_wall_left",
                "perch_wall_right",
                "perch_wall_ceiling",
                "l_clavicle",
                "l_upperarm",
                "arm_offsets",
                "dual",
                "forward",
                "tough",
                "replace",
                "root",
                "backward",
                "constant_overlay",
                "time",
                "scale",
                "rolloff",
                "perch_wall_center",
                "current_body_damage",
                "current_shield_damage",
                "body_vitality",
                "shield_vitality",
                "object_overshield_amount",
                "alive",
                "compass",
                "variant",
                "change_in_power",
                "change_in_position",
                "locked",
                "delay",
                "time_remaining",
                "range_remaining",
                "tracer",
                "acceleration_range",
                "projectile_attach",
                "heat",
                "turned_on",
                "illumination",
                "primary_ammunition",
                "primary_ammunition_ones",
                "primary_ammunition_tens",
                "secondary_ammunition",
                "primary_ejection_port",
                "secondary_ejection_port",
                "primary_rate_of_fire",
                "secondary_rate_of_fire",
                "primary_firing",
                "secondary_firing",
                "primary_charged",
                "secondary_charged",
                "integrated_light",
                "age",
                "primary_trigger_down",
                "secondary_trigger_down",
                "speed_absolute",
                "speed_forward",
                "speed_backward",
                "slide_absolute",
                "speed_slide_maximum",
                "turn_absolute",
                "jump",
                "boost",
                "velocity_air",
                "velocity_water",
                "velocity_ground",
                "velocity_forward",
                "velocity_left",
                "velocity_up",
                "left_tread_position",
                "right_tread_position",
                "left_tread_velocity",
                "right_tread_velocity",
                "front_left_tire_position",
                "front_right_tire_position",
                "back_left_tire_position",
                "back_right_tire_position",
                "front_left_tire_velocity",
                "front_right_tire_velocity",
                "back_left_tire_velocity",
                "back_right_tire_velocity",
                "wingtip_contrail",
                "thrust",
                "hover",
                "engine_hack",
                "engine_rpm",
                "wingtip_contrail_new",
                "mean_antigrav",
                "driver_seat_power",
                "gunner_seat_power",
                "aiming_change",
                "horizontal_aiming_change",
                "mouth_aperture",
                "integrated_light_power",
                "can_blink",
                "driver_seat_occupied",
                "gunner_seat_occupied",
                "flying_speed",
                "engine_power",
                "one",
                "zero",
                "weapon_illumination",
                "barrel_spin",
                "random_constant",
                "loop",
                "shield_depleted",
                "drop_right",
                "reload_enter",
                "reload_continue_empty",
                "reload_continue_full",
                "reload_exit",
                "melee_lunge",
                "melee_lunge_airborne",
                "infection_front",
                "infection_back",
                "infect",
                "thrash_front",
                "thrash_back",
                "melee_back",
                "pelvis",
                "melee_dash",
                "melee_dash_airborne",
                "bumper",
                "splitscreen_coop",
                "splitscreen_playlist",
                "splitscreen_custom",
                "system_link_coop",
                "system_link_playlist",
                "system_link_custom",
                "live_coop",
                "live_playlist",
                "live_custom",
                "live_quickmatch",
                "live_optimatch",
                "ground_speed_rear",
                "hud_wp_os_amt",
                "hud_wp_alpha",
                "hud_wp_theta",
                "hud_wp_arrow_t",
                "hud_elite",
                "hud_input1",
                "hud_input2",
                "hud_input3",
                "hud_input4",
                "change_map",
                "change_variant",
                "change_level",
                "change_difficulty",
                "change_playlist",
                "change_hopper",
                "switch_to_playlist",
                "switch_to_custom_game",
                "switch_to_coop",
                "switch_to_optimatch",
                "switch_to_arranged",
                "privacy_settings",
                "quick_options_help",
                "change_map_help",
                "change_variant_help",
                "change_level_help",
                "change_difficulty_help",
                "change_playlist_help",
                "change_hopper_help",
                "switch_to_playlist_help",
                "switch_to_custom_game_help",
                "switch_to_coop_help",
                "switch_to_optimatch_help",
                "switch_to_arranged_help",
                "current_options",
                "current_map",
                "current_variant",
                "current_level",
                "current_difficulty",
                "current_playlist",
                "current_hopper",
                "quick_options1",
                "quick_options2",
                "map",
                "level",
                "difficulty",
                "hopper",
                "key_online",
                "key_offline",
                "emblem_foreground_index",
                "emblem_background_index",
                "emblem_toggle_foreground",
                "emblem_foreground_map_scale_x",
                "emblem_background_map_scale_x",
                "emblem_active",
                "emblem_rank_index",
                "add_text_attachment",
                "add_voice_attachment",
                "key_ready_to_record",
                "key_recording_in_progress",
                "key_recording_complete",
                "key_playback_in_progress",
                "melee_strike_1",
                "melee_strike_2",
                "melee_strike_3",
                "melee_strike_4",
                "grip",
                "dth",
                "dth_mjr",
                "dth_slw",
                "dth_hdsht",
                "dth_slnt",
                "dth_fall",
                "dth_drama",
                "pain_mdm",
                "pain_mjr",
                "pain_shld",
                "pain_fall",
                "bump",
                "stun",
                "thrwn",
                "cower",
                "fall",
                "srprs",
                "emitter",
                "emitting",
                "logon_0",
                "change_logon_users_0",
                "friends_startup_0",
                "friends_enumeration_0",
                "friends_invite_0",
                "friends_invite_by_gamertag_0",
                "match_search_0",
                "session_create_0",
                "session_delete_0",
                "session_find_from_id_0",
                "session_update_0",
                "mutelist_startup_0",
                "mutelist_enumeration_0",
                "offering_search_for_new_0",
                "offering_enumerate_0",
                "offering_get_details_0",
                "offering_install_0",
                "offering_remove_0",
                "stats_get_0",
                "stats_set_0",
                "stats_reset_0",
                "leaderboard_query_0",
                "feedback_submission_0",
                "clans_enumerate_0",
                "clan_create_0",
                "clan_delete_0",
                "clan_update_0",
                "clan_member_recuit_0",
                "clan_member_recruit_by_gamertag_0",
                "clan_answer_recruit_0",
                "clan_member_change_properties_0",
                "clan_member_remove_0",
                "clan_members_enumerate_0",
                "presence_0",
                "message_delete_0",
                "message_send_0",
                "message_game_invite_send_0",
                "message_game_invite_answer_0",
                "message_details_retrieve_0",
                "message_attachment_download_0",
                "network_storage_upload_buffer_0",
                "network_storage_download_buffer_0",
                "network_storage_upload_package_0",
                "network_storage_download_package_0",
                "string_verify_0",
                "logon_1",
                "change_logon_users_1",
                "friends_startup_1",
                "friends_enumeration_1",
                "friends_invite_1",
                "friends_invite_by_gamertag_1",
                "match_search_1",
                "session_create_1",
                "session_delete_1",
                "session_find_from_id_1",
                "session_update_1",
                "mutelist_startup_1",
                "mutelist_enumeration_1",
                "offering_search_for_new_1",
                "offering_enumerate_1",
                "offering_get_details_1",
                "offering_install_1",
                "offering_remove_1",
                "stats_get_1",
                "stats_set_1",
                "stats_reset_1",
                "leaderboard_query_1",
                "feedback_submission_1",
                "clans_enumerate_1",
                "clan_create_1",
                "clan_delete_1",
                "clan_update_1",
                "clan_member_recuit_1",
                "clan_member_recruit_by_gamertag_1",
                "clan_answer_recruit_1",
                "clan_member_change_properties_1",
                "clan_member_remove_1",
                "clan_members_enumerate_1",
                "presence_1",
                "message_delete_1",
                "message_send_1",
                "message_game_invite_send_1",
                "message_game_invite_answer_1",
                "message_details_retrieve_1",
                "message_attachment_download_1",
                "network_storage_upload_buffer_1",
                "network_storage_download_buffer_1",
                "network_storage_upload_package_1",
                "network_storage_download_package_1",
                "string_verify_1",
                "enter_a",
                "enter_b",
                "enter_c",
                "enter_d",
                "melee_off_hand",
                "overheating_left",
                "overheated_left",
                "o_h_exit_left",
                "name",
                "description",
                "eye_trigger",
                "needler_trigger",
                "rocket_trigger",
                "one_way",
                "warn_rank_game_forfeit",
                "cancel_rank_game_forfeit",
                "proceed_rank_game_forfeit",
                "warn_leave_party",
                "cancel_leave_party",
                "proceed_leave_party",
                "warn_bring_party",
                "cancel_bring_party",
                "proceed_bring_party",
                "dont_bring_party",
                "phantom_speed",
                "phantom_power",
                "phantom_on",
                "gauss",
                "connecting",
                "migration",
                "stats",
                "player_name",
                "team_name",
                "primary_change_color",
                "fake_ui_player",
                "rank_icon",
                "land",
                "random_seed_1",
                "random_seed_2",
                "hud_autosave_begin",
                "hud_autosave_end",
                "hud_loading_begin",
                "hud_loading_end",
                "hud_saving_begin",
                "hud_saving_end",
                "hud_respawn_faliure_combat",
                "hud_respawn_faliure_unsafe",
                "hud_respawn_faliure_moving",
                "hud_respawn_faliure_vehicle",
                "unit_open",
                "unit_closed",
                "deploy",
                "vehicle_root",
                "hour",
                "minute",
                "second",
                "electricity",
                "leap_land",
                "melee_flurry",
                "electrical_power",
                "all_quiet",
                "time_hours",
                "time_minutes",
                "time_seconds",
                "morse_code",
                "holiday",
                "flashlights_allowed",
                "christmas",
                "player_gamertag_clan_format_string",
                "player_gamertag_clan_level_format_string",
                "vertical_thrust",
                "hint_corner_left",
                "hint_corner_right",
                "hint_bunker",
                "bunker_cover",
                "bunker_open",
                "ge_territories_territory_0",
                "ge_territories_territory_1",
                "ge_territories_territory_2",
                "ge_territories_territory_3",
                "ge_territories_territory_4",
                "ge_territories_territory_5",
                "ge_territories_territory_6",
                "ge_territories_territory_7",
                "melee_tackle",
                "a_select_b_back",
                "a_select_b_cancel",
                "a_enter_b_cancel",
                "y_xbox_live_players",
                "x_friends_options",
                "x_clan_options",
                "x_recent_players_options",
                "x_options",
                "a_select",
                "x_settings_a_select_b_back",
                "x_delete_a_select_b_done",
                "a_accept",
                "b_cancel",
                "y_xbox_live_players_a_select_b_back",
                "y_xbox_live_players_a_select_b_cancel",
                "y_xbox_live_players_a_enter_b_cancel",
                "y_xbox_live_players_a_select",
                "y_xbox_live_players_a_select_b_done",
                "y_xbox_live_players_a_accept",
                "y_xbox_live_players_b_cancel",
                "x_delete_a_select_b_back",
                "a_ok",
                "bomb_arming_amount",
                "bomb_is_unarmed",
                "bomb_is_arming",
                "bomb_is_armed",
                "default_player_profile_name",
                "player_profile_display_name",
                "slayer_display_name",
                "koth_display_name",
                "race_display_name",
                "oddball_display_name",
                "juggernaut_display_name",
                "headhunter_display_name",
                "ctf_display_name",
                "assault_display_name",
                "territories_display_name",
                "playlist_display_name",
                "saved_film_display_name",
                "keyboard_of_unlocking",
                "unlocked_extra_1",
                "unlocked_extra_2",
                "unlocked_extra_3",
                "unlocked_extra_4",
                "unlocked_extra_5",
                "unlocked_extra_6",
                "unlocked_extra_7",
                "unlocked_extra_8",
                "unlocked_extra_9",
                "unlocked_extra_10",
                "unlocked_extra_11",
                "unlocked_extra_12",
                "unlocked_extra_13",
                "unlocked_extra_14",
                "unlocked_extra_15",
                "unlocked_extra_16",
                "unlocked_extra_17",
                "unlocked_extra_18",
                "unlocked_extra_19",
                "unlocked_extra_20",
                "ellipses",
                "locked_description",
                "locked_value",
                "almost_never",
                "rarely",
                "somewhat",
                "often",
                "always",
                "wildcard",
                "tread_grind",
                "saving_game_variant",
                "saving_player_profile",
                "saving_game_progress",
                "saving_progress_short",
                "saving_progress_long",
                "reading_saved_game_progress",
                "scripted_object_function_a",
                "scripted_object_function_b",
                "scripted_object_function_c",
                "scripted_object_function_d",
                "missile",
                "support",
                "rifle",
                "pistol",
                "sword",
                "avg_life",
                "best_spree",
                "flag_saves",
                "flag_assists",
                "avg_control",
                "kills_on_hill",
                "kills_from_hill",
                "kills_on_ball",
                "kills_from_ball",
                "longest_control",
                "juggs_killed",
                "kills_as_jugg",
                "terrs_taken",
                "terrs_lost",
                "bomb_grabs",
                "bomb_kills",
                "place",
                "player",
                "score",
                "time_format",
                "assists",
                "deaths",
                "kills",
                "pvp_killed",
                "pvp_killed_by",
                "suicides",
                "died_most",
                "killed_most",
                "total_medals",
                "best_medal",
                "multiple_kill_2",
                "multiple_kill_3",
                "multiple_kill_4",
                "multiple_kill_5",
                "multiple_kill_6",
                "multiple_kill_7",
                "sniper_kill",
                "collision_kill",
                "bash_kill",
                "stealth_kill",
                "killed_vehicle",
                "boarded_vehicle",
                "plase_stick",
                "5_kills_in_a_row",
                "10_kills_in_a_row",
                "15_kills_in_a_row",
                "20_kills_in_a_row",
                "25_kills_in_a_row",
                "flag_grab",
                "flag_carrier_kill",
                "flag_return",
                "bomb_plant",
                "bomb_carrier_kill",
                "bomb_diffused",
                "percentage_format",
                "shots_hit",
                "shots_fired",
                "hit_percentage",
                "head_shots",
                "matched_player",
                "estimated_wait",
                "starting_over",
                "players_needed",
                "no_players_needed",
                "a_select_player_b_done",
                "a_select_player_b_leave_party",
                "b_done",
                "b_leave_party",
                "shake_fist",
                "cheer",
                "taunt",
                "brace",
                "point",
                "hold",
                "wave",
                "advance",
                "fallback",
                "english",
                "japanese",
                "german",
                "french",
                "spanish",
                "italian",
                "korean",
                "chinese",
                "portuguese",
                "resume_solo_help",
                "restart_solo_help",
                "coop_help",
                "solo_help",
                "brsrk",
                "shakefist",
                "variant_ctf",
                "variant_slayer",
                "variant_oddball",
                "variant_king",
                "variant_juggernaut",
                "variant_territories",
                "variant_assault",
                "meleeleap",
                "pstcmbt",
                "dynamic_source",
                "moving_vehicle",
                "projectile",
                "multiplayer",
                "enemy",
                "friend",
                "enemy_vehicle",
                "friendly_vehicle",
                "empty_vehicle",
                "oddball_inclusion",
                "oddball_exclusion",
                "hill_inclusion",
                "hill_exclusion",
                "last_race_flag",
                "dead_ally",
                "controlled_territory",
                "right_hand",
                "l_thruster_target",
                "r_thruster_target",
                "reanimate",
                "secret",
                "network_unknown",
                "network_loading_map",
                "network_running",
                "network_connecting",
                "network_joining",
                "network_reestablishing",
                "network_leaving",
                "ffa_title",
                "ffa_description",
                "small_team_title",
                "small_team_description",
                "head_to_head_title",
                "head_to_head_description",
                "big_team_title",
                "big_team_description",
                "small_team_clanmatch_title",
                "small_team_clanmatch_description",
                "big_team_clanmatch_title",
                "big_team_clanmatch_description",
                "small_team_unranked_title",
                "small_team_unranked_description",
                "test_multi_team_title",
                "test_multi_team_description",
                "test_unranked_multi_team_title",
                "test_unranked_multi_team_description",
                "test_unranked_ffa_title",
                "test_unranked_ffa_description",
                "test_unranked_small_team_title",
                "test_unranked_small_team_description",
                "warthog_chaingun_illumination",
                "precaching_failed_locally",
            };
#endregion
        String_IDs = new StringID[Strings.Length];
        for (short i = 0; i < Strings.Length; i++)
        {
            String_IDs[i] = new StringID(i, (sbyte)Encoding.UTF8.GetByteCount(Strings[i]));
        }
    }

    IEnumerator<string> IEnumerable<string>.GetEnumerator()
    {
        foreach (var str in Strings) yield return str;
    }

    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
    {
        return Strings.GetEnumerator();
    }

    IEnumerator<StringID> IEnumerable<StringID>.GetEnumerator()
    {
        foreach (var string_id in String_IDs) yield return string_id;
    }

    public bool Contains(StringID id)
    { return Array.IndexOf<StringID>(String_IDs, id) >= 0; }
}